C
C     FFTE: A FAST FOURIER TRANSFORM PACKAGE
C
C     (C) COPYRIGHT SOFTWARE, 2000, 2001, 2002, ALL RIGHTS RESERVED
C                BY
C         DAISUKE TAKAHASHI
C         INSTITURE OF INFORMATION SCIENCES AND ELECTRONICS,
C         UNIVERSITY OF TSUKUBA
C         1-1-1 TENNODAI, TSUKUBA-SHI, IBARAKI 305-8573, JAPAN
C         E-MAIL: daisuke@is.tsukuba.ac.jp
C
C
C     ZFFT2D SPEED TEST PROGRAM
C
C     FORTRAN77 SOURCE PROGRAM
C
C     WRITTEN BY DAISUKE TAKAHASHI
C
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'param.h'
      PARAMETER (NDA=1048576)
      COMPLEX*16 A(NDA+NP)
      REAL*4 TARRAY(2)
      DIMENSION LNX(3),LNY(3)
C
      WRITE(6,*) ' NX,NY ='
      READ(5,*) NX,NY
      CALL FACTOR(NX,LNX)
      CALL FACTOR(NY,LNY)
C
      CALL INIT(A,NX*NY)
      CALL ZFFT2D(A,NX,NY,1)
      LOOP=1
C
   10 CONTINUE
      TIME1=ETIME(TARRAY)
      DO I=1,LOOP
      CALL ZFFT2D(A,NX,NY,1)
      END DO
      TIME2=ETIME(TARRAY)
      TIME0=TIME2-TIME1
      IF (TIME0 .LT. 1.0D0) THEN
        LOOP=LOOP*2
        GO TO 10
      END IF
      TIME0=TIME0/DBLE(LOOP)
      FLOPS=(2.5D0*DBLE(LNX(1)+LNY(1))
     1       +4.66666666666666D0*DBLE(LNX(2)+LNY(2))
     2       +6.8D0*DBLE(LNX(3)+LNY(3)))*2.0D0*DBLE(NX*NY)/TIME0/1.0D6
      WRITE(6,*) ' NX =',NX,' NY =',NY,' TIME =',TIME0,
     1           FLOPS,' MFLOPS'
C
      STOP
      END
      SUBROUTINE INIT(A,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*)
C
      DO 10 I=1,N
        A(I)=(0.0D0,0.0D0)
   10 CONTINUE
      RETURN
      END
