C
C     (C) COPYRIGHT SOFTWARE, 2000-2003, ALL RIGHTS RESERVED
C                BY
C         DAISUKE TAKAHASHI
C         INSTITURE OF INFORMATION SCIENCES AND ELECTRONICS,
C         UNIVERSITY OF TSUKUBA
C         1-1-1 TENNODAI, TSUKUBA, IBARAKI 305-8573, JAPAN
C         E-MAIL: daisuke@is.tsukuba.ac.jp
C
C
C     PZFFT1D SPEED TEST PROGRAM
C
C     FORTRAN77 + MPI SOURCE PROGRAM
C
C     WRITTEN BY DAISUKE TAKAHASHI
C
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'mpif.h'
      INCLUDE 'param.h'
      PARAMETER (NDA=1048576,LOOP=10)
      COMPLEX*16 A(NDA),B(NDA),WW(NDA3*NDA3),WWW(NDA)
      DIMENSION IP(3)
C
      CALL MPI_INIT(IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ME,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NPU,IERR)
C
      IF (ME .EQ. 0) THEN
        WRITE(6,*) ' N ='
        READ(5,*) N
      END IF
      CALL MPI_BCAST(N,1,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
      CALL FACTOR(N,IP)
C
      NN=N/NPU
      CALL INIT(A,NN,ME,NPU)
      CALL PZFFT1D(A,B,WW,WWW,N,ME,NPU,1)
C
      TIME0=2.0D0**52
      DO I=1,LOOP
      CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
      IF (ME .EQ. 0) THEN
        TIME1=MPI_WTIME()
      END IF
C
      CALL PZFFT1D(A,B,WW,WWW,N,ME,NPU,1)
C
      CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
      IF (ME .EQ. 0) THEN
        TIME2=MPI_WTIME()
        TIME0=DMIN1(TIME0,TIME2-TIME1)
      END IF
      END DO
      IF (ME .EQ. 0) THEN
        FLOPS=(2.5D0*DBLE(IP(1))+4.66666666666666D0*DBLE(IP(2))
     1         +6.8D0*DBLE(IP(3)))*2.0D0*DBLE(N)/TIME0/1.0D6
        WRITE(6,*) ' NPU =',NPU
        WRITE(6,*) ' N =',N,' TIME =',TIME0,FLOPS,' MFLOPS'
      END IF
C
      CALL MPI_FINALIZE(IERR)
      STOP
      END
      SUBROUTINE INIT(A,NN,ME,NPU)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*)
C
      N=NN*NPU
      DO 10 I=1,NN
        A(I)=(0.0D0,0.0D0)
   10 CONTINUE
      RETURN
      END
