
#include "sort.h"
#include "search.h"

#include "fxttypes.h"
#include "rand.h"  // rnd01()

#include "jjassert.h"
//#include "newop.h"

#include "fxtio.h"
#include "fxtiomanip.h"

#include <cstdlib> // atol()


void
print(const char *bla, const double *f, ulong n)
{
    cout << endl;
    if ( bla )  cout << bla << endl;

    for (ulong k=0; k<n; ++k)
    {
        double r = f[k];

        cout.width(4);
        cout.flags(ios::right);
        cout << k << ":  ";

        cout.precision(5);
        cout.flags(ios::left);
        cout.width(8);
        cout << r;
        cout << endl;
    }
    cout << endl;
}
// -------------------------


int
main(int argc, char **argv)
{
    ulong n = 25;
    if ( argc>1 )  n = atol(argv[1]);

    double *f = new double[n];

    rnd01(f, n);
    print("random values:", f, n);

    double v = f[n/2];


//    ulong p = partition(f, n);
//    print("partitioned values:", f, n);
//    cout << "p=" << p << endl;
//    cout << "p-max=" << max(f, p) << endl;
//    cout << "p-min=" << min(f+p, n-p) << endl;


//    selection_sort(f, n);
    quick_sort(f, n);
    print("sorted values:", f, n);

    jjassert( is_sorted(f, n) );

    cout << "searching for v=" << v << endl;
    ulong i = bsearch(f, n, v);
    jjassert( i<n );
    cout << "found at index " << i << endl;

    return 0;
}
// -------------------------
