
#include "fxttypes.h"
#include "mod.h"
#include "factor.h"
#include "bit2pow.h"  // ld()

#include "fxtio.h"
#include "fxtiomanip.h"


#if    ( USE_MODM==1 )
#warning "FYI: USE_MODM is #defined "
#endif


void
mod_info0()
{
    cout << "-------- start MOD_INIT():  m=" << mod::modulus <<  " --------" << endl;
}
// -------------------------

void
mod_info99()
{
    cout << "-------- end MOD_INIT(). --------" << endl;
}
// -------------------------

void
mod_info1()
{
    umod_t m = mod::modulus;

//    cout << "using ";
//#if  ( USE_64BIT_MOD_T )
//    cout << "64 bit";
//#else
//    cout << "32 bit";
//#endif
//    cout << " mod type " << endl;

    cout << "modulus= " << m
         << " == 0x" << hex << m << dec << endl;

    cout << "modulus is ";
    if ( !mod::modulus_cyclic() )  cout << "NOT ";
    cout << "cyclic" << endl;

    cout << "modulus is ";
    if ( mod::modfact.prime(0)==mod::modulus )
    {
        cout << "prime " << endl;
    }
    else
    {
        cout << "composite  ";
        cout << " == " << mod::modfact << endl;
    }

    cout << "bits(modulus)= ";
    cout.precision(8);
    cout << mod::mbitsd;

//    cout.precision(16);
    double d = mod::mbits - mod::mbitsd;
    if ( d!=0 )  cout << "  == " << mod::mbits << " - " << d;

    cout << endl;
}
// -------------------------


void
mod_info2()
{
    cout << "phi(modulus)= " << (mod::phi)
         << " == 0x" << hex <<  (mod::phi) << dec
         << " == " << mod::phifact
//         << "   ==phi(modulus)"
         << endl;

    cout << "maxorder= " << (mod::maxorder)
         << " == 0x" << hex <<  (mod::maxorder) << dec
         << " == " << mod::xfact
//         << "   (maximal possible order) "
         << endl;
}
// -------------------------


void
mod_info3()
{
    cout << " 1/2 = " << mod::half
         << " == 0x" << hex << (mod::half) << dec
         << endl;

    cout << "maxordelem= " << (mod::maxordelem)
         << " == 0x" << hex << (mod::maxordelem) << dec
         << endl;

    cout << "invmaxordelem= "
         << mod::invmaxordelem
         << " == 0x" << hex << (mod::invmaxordelem) << dec
         << endl;

    umod_t r = order( mod::two );
    cout << "order(2)= " << r
         << " == " << factorization(r) << endl;

    for (umod_t x=4, xe=2, t=0;  x<mod::modulus;  x*=2, ++xe)
    {
        r = order( mod(x) );
        umod_t ze = ld(r);
        if ( ((1ULL<<ze) == r) && !(r & t) )
        {
            t |= r;
            cout << "order(2^" << xe << ")=2^" << ze << endl;
        }
    }
}
// -------------------------


void
mod_info4()
{
    umod_t m2 = mod::max2pow;
    cout << "max2pow= " << m2
//         << "   (root of order 2**ldn exists for ldn<=max2pow)"
         << "   (max FFT length = 2**" << m2
         << " == " << ((umod_t)1<<m2) << ")"
         << endl;

    if ( mod::modfact.prime(0)==2 )
    {
        cout << "2\\modulus, cannot divide by 2 (or 2**n)" << endl;
        cout << " =--> no length 2**n inverse FFT !" << endl;
    }

    cout << "root2pow(max2pow)=" << mod::root2pow(m2)
         << "   root2pow(-max2pow)=" << mod::root2pow(-m2)
         << endl;

    if ( m2 > 0 )
    {
        if ( mod::root2pow(1) != (mod::minus1) )
            cout << "root2pow(1)=" << mod::root2pow(1) << " != -1  (!)"
                 << endl;
    }

//    void mod_info_roots();
}
// -------------------------


void
mod_info_roots()
{
    umod_t m2 = mod::max2pow;

    for (ulong k=0; k<=m2; ++k)
    {
        cout << setw(2) << k << ":"; // << endl;
        cout << "  r=" << setw(21) << mod::root_2pow[k];
        cout << "   c=" << setw(21) << mod::cos[k];
        cout << "  is=" << setw(21) << mod::isin[k];
        cout << endl;
        cout << "    rm=" << setw(21) << mod::root_m2pow[k];
        cout << "  cm=" << setw(21) << mod::cosm[k];
        cout << " ism=" << setw(21) << mod::isinm[k];
        cout << endl;
//
//        cout << endl;
    }
}
// -------------------------


//void
//mod_info5()
//{
//    // ------- montgomery section:
//    cout << "mg_bits=" << mod::mg_bits << endl;
//    cout << "mg_mask=" << mod::mg_mask << endl;
//    cout << "mg_r=" << mod::mg_r << endl;
//    cout << "mg_r_prime=" << mod::mg_r_prime << endl;
//    cout << "mg_m_prime=" << mod::mg_m_prime << endl;
//}
//// ------------------------------

