/*
 * Copyright (c) 2000 Carnegie Mellon University
 * Copyright (c) 1997-1999 Massachusetts Institute of Technology
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,MA  02111-1307 USA
 *
 */

/* fftw_notw_1.c */

/* This file is a slightly modified version of the 
 * file fn_2.c from the software package FFTW, 
 * version 2.1.1, by M. Frigo and S. G. Johnson.
 * Information about FFTW is available at 
 * http://www.fftw.org
 *
 * The modification to the FFTW file is that the 
 * FFT is now applied in-place.  The file was modified
 * on 6/15/00.
 *
 * The function in this file can be replaced with any 
 * function that computes 
 *
 * x = F_2 * x, performed at stride = <stride>.
 */

#include "spiral_fft.h"

extern void apply_small1( struct fft_s *UNUSED_PARAMETER(F), int stride, Vector(x) ) 
{
     fftw_real tmp1;
     fftw_real tmp2;
     fftw_real tmp3;
     fftw_real tmp4;
     tmp1 = c_re(at(x,0));
     tmp2 = c_re(at(x,stride));
     c_re(at(x,stride)) = tmp1 - tmp2;
     c_re(at(x,0)) = tmp1 + tmp2;
     tmp3 = c_im(at(x,0));
     tmp4 = c_im(at(x,stride));
     c_im(at(x,stride)) = tmp3 - tmp4;
     c_im(at(x,0)) = tmp3 + tmp4;
}

